#include <array>
#include <iostream>
#include <algorithm>
#include <fstream>
#include <random>
#include <dirent.h>
#include <vector>
#include <cmath>
#include <queue>
#include <algorithm>
// #include <google/sparse_hash_map>
#include "make_pattern.h"
#include "go_board.h"
#include "global.h"

MakePattern::MakePattern()
{
}

int MakePattern::getPattern3x3ToBit(const std::array<int, 9> &pattern)
{
    int bit_pattern = 0;
    for (int i = 0; i < 9; ++i) {
        bit_pattern <<= 2;
        if (pattern[i] == Black) {
            bit_pattern |= 0;
        }
        else if (pattern[i] == White) {
            bit_pattern |= 1;
        }
        else if (pattern[i] == Empty) {
            bit_pattern |= 2;
        }
        else if (pattern[i] == Wall) {
            bit_pattern |= 3;
        }
    }
    return bit_pattern;
}

std::array<int, 9> MakePattern::getRotatePattern3x3(const std::array<int, 9> &pattern)
{
    std::array<int, 9> rotate_pattern;
    rotate_pattern[0] = pattern[6];
    rotate_pattern[1] = pattern[3];
    rotate_pattern[2] = pattern[0];
    rotate_pattern[3] = pattern[7];
    rotate_pattern[4] = pattern[4];
    rotate_pattern[5] = pattern[1];
    rotate_pattern[6] = pattern[8];
    rotate_pattern[7] = pattern[5];
    rotate_pattern[8] = pattern[2];

    return rotate_pattern;
}

std::array<int, 9> MakePattern::getReversePattern3x3(const std::array<int, 9> &pattern)
{
    std::array<int, 9> inverse_pattern;
    inverse_pattern[0] = pattern[2];
    inverse_pattern[1] = pattern[1];
    inverse_pattern[2] = pattern[0];
    inverse_pattern[3] = pattern[5];
    inverse_pattern[4] = pattern[4];
    inverse_pattern[5] = pattern[3];
    inverse_pattern[6] = pattern[8];
    inverse_pattern[7] = pattern[7];
    inverse_pattern[8] = pattern[6];

    return inverse_pattern;
}


void MakePattern::printPattern3x3(const std::array<int, 9> &pattern)
{
    for (int i = 0; i < 9; ++i) {
        if (!(i % 3)) {
            std::cerr << std::endl;
        }
        std::cerr << (pattern[i] == Black ? "B" :
                      pattern[i] == White ? "W" :
                      pattern[i] == Empty ? "+" : "N");
    }
    std::cerr << std::endl;
}

void MakePattern::printPattern5x5(const std::array<int, 25> &pattern)
{
    for (int i = 0; i < 25; ++i) {
        if (!(i % 5)) {
            std::cerr << std::endl;
        }
        std::cerr << (pattern[i] == Black ? "B" :
                      pattern[i] == White ? "W" :
                      pattern[i] == Empty ? "+" : "N");
    }
    std::cerr << std::endl;
}

void MakePattern::printBitPattern5x5(const std::bitset<50> &pattern)
{
    for (int i = 0; i < 25; ++i) {
        if (!(i % 5)) {
            std::cerr << std::endl;
        }
        std::cerr << (pattern[2 * i] == 0 && pattern[2 * i + 1] == 0 ? "B" :
                      pattern[2 * i] == 1 && pattern[2 * i + 1] == 0 ? "W" :
                      pattern[2 * i] == 0 && pattern[2 * i + 1] == 1 ? "+" : "N");
    }
    std::cerr << std::endl;
}

void MakePattern::printBitPattern9x9(const std::bitset<338> &pattern)
{
    for (int i = 0; i < 169; ++i) {
        if (!(i % kexpanded_board_size)) {
            std::cerr << std::endl;
        }
        std::cerr << (pattern[2 * i] == 0 && pattern[2 * i + 1] == 0 ? "B" :
                      pattern[2 * i] == 1 && pattern[2 * i + 1] == 0 ? "W" :
                      pattern[2 * i] == 0 && pattern[2 * i + 1] == 1 ? "+" : "N");
    }
    std::cerr << std::endl;
}

void MakePattern::printPattern9x9(const std::array<int, karray_board_size> &pattern)
{
    for (int i = 0; i <  karray_board_size; ++i) {
        if (!(i % kexpanded_board_size)) {
            std::cerr << std::endl;
        }
        std::cerr << " " << (pattern[i] == Black ? "B" : pattern[i] ==White ? "W" : pattern[i] == Empty ? "+" : "N");
    }
    std::cerr << std::endl << std::endl;
}

void MakePattern::printPattern243(const std::bitset<243> &pattern)
{
    for (int i = 0; i < kboard_square_size; ++i) {
        if (!(i % kboard_size)) {
            std::cerr << std::endl;
        }
        int base = i * 3;
        if (pattern[base] == 1) {
            std::cerr << " + ";
        }
        else if (pattern[base + 1] == 1) {
            std::cerr << " B ";
        }
        else {
            std::cerr << " W ";
        }
    }
    std::cerr << std::endl;
}

void MakePattern::testMakePattern()
{


    GoBoard go_board;

    std::array<int, 9> pattern, tmp_pattern;
    pattern[0] = 3;
    pattern[1] = 3;
    pattern[2] = 3;
    pattern[3] = 3;
    pattern[4] = 3;
    pattern[5] = 3;
    pattern[6] = 3;
    pattern[7] = 3;
    pattern[8] = 3;
    printPattern3x3(pattern);
    tmp_pattern = getRotatePattern3x3(pattern);
    printPattern3x3(tmp_pattern);
    tmp_pattern = getReversePattern3x3(pattern);
    printPattern3x3(tmp_pattern);
    int bit_pattern = getPattern3x3ToBit(pattern);
    std::cerr << bit_pattern << std::endl;
    return;
    for (int i = 0; i < 9; ++i) {
        std::cerr << (bit_pattern & 3) << std::endl;
        bit_pattern >>= 2;
    }
    printPattern3x3(pattern);
    printPattern3x3(getBitToPattern3x3(getMinPattern3x3ToBit(pattern)));
    printPattern3x3(getBitToPattern3x3(5653));
    doMakePattern();
    std::cerr << pattern3x3_count_[0][5653] << std::endl;

    for (int i = 0; i < 10; ++i) {
        int max_element_index = std::distance(pattern3x3_count_[0].begin(),
                                              std::max_element(pattern3x3_count_[0].begin(), pattern3x3_count_[0].end()));
        printPattern3x3(getBitToPattern3x3(max_element_index));
        std::cerr << *std::max_element(pattern3x3_count_[0].begin(), pattern3x3_count_[0].end()) << std::endl;
        pattern3x3_count_[0][max_element_index] = -1;
    }

    std::cerr << "white" << std::endl;
    for (int i = 0; i < 10; ++i) {
        int max_element_index = std::distance(pattern3x3_count_[1].begin(),
                                              std::max_element(pattern3x3_count_[1].begin(), pattern3x3_count_[1].end()));
        printPattern3x3(getBitToPattern3x3(max_element_index));
        std::cerr << *std::max_element(pattern3x3_count_[1].begin(), pattern3x3_count_[1].end()) << std::endl;
        pattern3x3_count_[1][max_element_index] = -1;
    }


    std::array<int, 25> pattern5x5;
    std::array<int, karray_board_size> pattern9x9 = getReversePattern9x9(go_board.getGoBoard());
    for (int i = kboard_start_index; i < karray_board_size; ++i) {
        if (!(i % kexpanded_board_size)) {
            std::cerr << std::endl;
        }
        if (pattern9x9[i] == Empty) {
            std::cerr << getPattern9x9Count(pattern9x9, i, 0) << "  ";
        }
    }
    std::cerr << std::endl;
}

int MakePattern::getPattern9x9Count(const std::array<int, karray_board_size> &go_board, int pos, int color)
{
    std::bitset<338> bit_pattern9x9 = getBitPattern9x9(go_board);
    std::unordered_map<std::bitset<338>, std::unordered_map<int, int> >::iterator it;
    // google::sparse_hash_map<std::bitset<338>, google::sparse_hash_map<int, int> >::iterator it;

    if (color == Black) {
        it = black_pattern9x9_count_.find(bit_pattern9x9);
        if (it == black_pattern9x9_count_.end()) {
            return 0;
        }
        auto its = it->second.find(pos);
        if (its == it->second.end()) {
            return 0;
        }
        return black_pattern9x9_count_[bit_pattern9x9][pos];
    }
    else if (color == White) {
        it = white_pattern9x9_count_.find(bit_pattern9x9);
        if (it == white_pattern9x9_count_.end()) {
            return 0;
        }
        auto its = it->second.find(pos);
        if (its == it->second.end()) {
            return 0;
        }
        return white_pattern9x9_count_[bit_pattern9x9][pos];
    }
    return 0;
}

std::array<std::pair<int, int>, kboard_square_size> MakePattern::getPatternCountBoard(const GoBoard &current_go_board, int color, int mode)
{
    std::array<int, karray_board_size> go_board = current_go_board.getGoBoard();
    // std::array<int, karray_board_size> pattern_go_board_test = current_go_board.getPatternGoBoard();
    int pre_pos = current_go_board.getPrePosition();
    int second_pre_pos = current_go_board.getSecondPrePosition();

    std::array<std::pair<int, int>, kboard_square_size>  pattern_count_board;
    int pos;

    if (mode == 0) {
        for (int i = 0; i <  kboard_square_size; ++i) {
            pos = board9x9_index[i];
            if (go_board[pos] == Empty) {
                pattern_count_board[i] = std::make_pair(transition_count_[second_pre_pos][pre_pos][pos] + two_transition_count_[pre_pos][pos], pos);
            }
            else {
                pattern_count_board[i] = std::make_pair(0, pos);
            }
        }
        std::sort(pattern_count_board.rbegin(), pattern_count_board.rend());
        return pattern_count_board;
    }
    else if (mode == 1) {
        std::array<int, karray_board_size> pattern_go_board = current_go_board.getPatternGoBoard();

        if (color == Black) {
            for (int i = 0; i <  kboard_square_size; ++i) {
                pos = board9x9_index[i];
                if (go_board[i] == Empty) {
                    pattern_count_board[i] = std::make_pair(black_bit_pattern3x3_count_[pattern_go_board[pos]],pos);
                }
                else {
                    pattern_count_board[i] = std::make_pair(0, pos);
                }
            }
        }
        else if (color == White) {
            for (int i = 0; i <  kboard_square_size; ++i) {
                pos = board9x9_index[i];
                if (go_board[pos] == Empty) {
                    pattern_count_board[i] = std::make_pair(white_bit_pattern3x3_count_[pattern_go_board[pos]],pos);
                }
                else {
                    pattern_count_board[i] = std::make_pair(0, pos);
                }
            }
        }
        std::sort(pattern_count_board.rbegin(), pattern_count_board.rend());
        return pattern_count_board;
    }
    else if (mode == 2) {
        std::array<int, karray_board_size> pattern_go_board = current_go_board.getPatternGoBoard();
        // std::array<double,  karray_board_size> freqenc_boardy = getFrequencyBoard(go_board, color, 3);

        if (color == Black) {
            for (int i = 0; i <  kboard_square_size; ++i) {
                pos = board9x9_index[i];

                if (go_board[pos] == Empty) {
                    int with_pos_count = pattern3x3_with_pos_count_[0][0][pos][pattern_go_board[pos]]
                                 + pattern3x3_with_pos_count_[0][1][pos][pattern_go_board[getNorthWest(pos)]]
                                 + pattern3x3_with_pos_count_[0][2][pos][pattern_go_board[getNorthEast(pos)]]
                                 + pattern3x3_with_pos_count_[0][3][pos][pattern_go_board[getSouthWest(pos)]]
                                 + pattern3x3_with_pos_count_[0][4][pos][pattern_go_board[getSouthEast(pos)]];
                    pattern_count_board[i] = std::make_pair(with_pos_count + 10 * black_pattern5x5_count_[getBitPattern5x5(getPattern5x5(go_board, pos))], pos);
                }
                else {
                    pattern_count_board[i] = std::make_pair(0, pos);
                }
            }
            std::sort(pattern_count_board.rbegin(), pattern_count_board.rend());
            return pattern_count_board;
        }
        else if (color == White) {
           for (int i = 0; i <  kboard_square_size; ++i) {
               pos = board9x9_index[i];
               if (go_board[pos] == Empty) {

                   int with_pos_count = pattern3x3_with_pos_count_[1][0][pos][pattern_go_board[pos]]
                                + pattern3x3_with_pos_count_[1][1][pos][pattern_go_board[getNorthWest(pos)]]
                                + pattern3x3_with_pos_count_[1][2][pos][pattern_go_board[getNorthEast(pos)]]
                                + pattern3x3_with_pos_count_[1][3][pos][pattern_go_board[getSouthWest(pos)]]
                                + pattern3x3_with_pos_count_[1][4][pos][pattern_go_board[getSouthEast(pos)]];

                   pattern_count_board[i] = std::make_pair(with_pos_count + 10 * white_pattern5x5_count_[getBitPattern5x5(getPattern5x5(go_board, pos))], pos);

               }
               else {
                   pattern_count_board[i] = std::make_pair(0, pos);
               }
           }
           std::sort(pattern_count_board.rbegin(), pattern_count_board.rend());
           return pattern_count_board;
        }


        std::sort(pattern_count_board.rbegin(), pattern_count_board.rend());
        return pattern_count_board;
    }
    else if (mode == 3) {
        std::array<int, karray_board_size> pattern_go_board = current_go_board.getPatternGoBoard();
        std::bitset<50> bit_pattern5x5;
        std::array<int, 25> pattern5x5;
        std::array<int, 9> pattern3x3;
        std::unordered_map<std::bitset<50>, int>::const_iterator it;

        // std::array<double,  karray_board_size> freqenc_boardy = getFrequencyBoard(go_board, color, 3);

        if (color == Black) {
            for (int i = 0; i <  kboard_square_size; ++i) {
                pos = board9x9_index[i];
                if (go_board[pos] == Empty && getManhattanDistance(pre_pos, pos) <= 1) {
                    int with_pos_count = pattern3x3_with_pos_count_[0][0][pos][pattern_go_board[pos]];
                                 + pattern3x3_with_pos_count_[0][1][pos][pattern_go_board[getNorthWest(pos)]]
                                 + pattern3x3_with_pos_count_[0][2][pos][pattern_go_board[getNorthEast(pos)]]
                                 + pattern3x3_with_pos_count_[0][3][pos][pattern_go_board[getSouthWest(pos)]]
                                 + pattern3x3_with_pos_count_[0][4][pos][pattern_go_board[getSouthEast(pos)]];
                    pattern_count_board[i] = std::make_pair(/*with_pos_count + */black_pattern5x5_count_[getBitPattern5x5(getPattern5x5(go_board, pos))], pos);
                }
                else {
                    pattern_count_board[i] = std::make_pair(0, pos);
                }
            }
            std::sort(pattern_count_board.rbegin(), pattern_count_board.rend());
            return pattern_count_board;
        }
        else if (color == White) {
           for (int i = 0; i <  kboard_square_size; ++i) {
               pos = board9x9_index[i];
               if (go_board[pos] == Empty && getManhattanDistance(pre_pos, pos) <= 1) {
                   int with_pos_count = pattern3x3_with_pos_count_[1][0][pos][pattern_go_board[pos]]
                                + pattern3x3_with_pos_count_[1][1][pos][pattern_go_board[getNorthWest(pos)]]
                                + pattern3x3_with_pos_count_[1][2][pos][pattern_go_board[getNorthEast(pos)]]
                                + pattern3x3_with_pos_count_[1][3][pos][pattern_go_board[getSouthWest(pos)]]
                                + pattern3x3_with_pos_count_[1][4][pos][pattern_go_board[getSouthEast(pos)]];
                   pattern_count_board[i] = std::make_pair(/*with_pos_count + */white_pattern5x5_count_[getBitPattern5x5(getPattern5x5(go_board, pos))], pos);

               }
               else {
                   pattern_count_board[i] = std::make_pair(0, pos);
               }
           }
           std::sort(pattern_count_board.rbegin(), pattern_count_board.rend());
           return pattern_count_board;
        }


        std::sort(pattern_count_board.rbegin(), pattern_count_board.rend());
        return pattern_count_board;
    }


    return pattern_count_board;
}

std::array<int, 9> MakePattern::getPattern3x3(const std::array<int, karray_board_size> go_board, int pos)
{
    std::array<int, 9> pattern3x3;
    pattern3x3[0] = go_board[getWest(getNorth(pos))];
    pattern3x3[1] = go_board[getNorth(pos)];
    pattern3x3[2] = go_board[getEast(getNorth(pos))];
    pattern3x3[3] = go_board[getWest(pos)];
    pattern3x3[4] = go_board[pos];
    pattern3x3[5] = go_board[getEast(pos)];
    pattern3x3[6] = go_board[getWest(getSouth(pos))];
    pattern3x3[7] = go_board[getSouth(pos)];
    pattern3x3[8] = go_board[getEast(getSouth(pos))];

    return pattern3x3;
}

void MakePattern::printTransitionCount(GoBoard go_board, int color)
{   
    int pre_pos = go_board.getPrePosition();
    int second_pre_pos = go_board.getSecondPrePosition();
    int third_pre_pos = go_board.getThirdPrePosition();
    std::array<std::pair<int, int>, kboard_square_size>  transition_count_board;
    int pos;

    for (int i = 0; i < kboard_square_size; ++i) {
        pos = board9x9_index[i];
        std::cerr << "[" << four_transition_count_[third_pre_pos][second_pre_pos][pre_pos][pos] << " " <<  pos;
        printPosition(pos);
        transition_count_board[i] = std::make_pair(four_transition_count_[third_pre_pos][second_pre_pos][pre_pos][pos], pos);
        // transition_count_board[i] = std::make_pair(transition_count_[second_pre_pos][pre_pos][pos], pos);
        // transition_count_board[i] = std::make_pair(two_transition_count_[pre_pos][pos], pos); // std::make_pair(transition_count_[second_pre_pos][pre_pos][pos], pos);
    }
    std::sort(transition_count_board.rbegin(), transition_count_board.rend());
    for (int i = 0; i < 10; ++i) {
        double move_probability = (double)transition_count_board[i].first / (double)four_transition_count_[third_pre_pos][second_pre_pos][pre_pos][0];
        // double move_probability = (double)transition_count_board[i].first / (double)transition_count_[second_pre_pos][pre_pos][0];
        // double move_probability = (double)transition_count_board[i].first / (double)two_transition_count_[pre_pos][0];  // (double)transition_count_[second_pre_pos][pre_pos][0];
        int move = transition_count_board[i].second;
        std::cerr << (move_probability * 100.0) << " ";
        printPosition(move);
    }
    std::cerr << std::endl;

    third_pre_pos = second_pre_pos;
    second_pre_pos = pre_pos;
    pre_pos =  transition_count_board[0].second;
    printPosition(pre_pos);
    int max_count = 10;
    for (int j = 0; j < max_count; ++j) {
        for (int i = 0; i < kboard_square_size; ++i) {
            pos = board9x9_index[i];
            transition_count_board[i] = std::make_pair(four_transition_count_[third_pre_pos][second_pre_pos][pre_pos][pos], pos);
        }
        std::sort(transition_count_board.rbegin(), transition_count_board.rend());
        if (transition_count_board[0].first == 0) {
            break;
        }
        third_pre_pos = second_pre_pos;
        second_pre_pos = pre_pos;
        pre_pos =  transition_count_board[0].second;
        printPosition(pre_pos);
    }


}


int MakePattern::getMinPattern3x3ToBit(std::array<int, 9> pattern)
{
    int min_bit_pattern = getPattern3x3ToBit(pattern);
    int bit_pattern;
    for (int i = 0; i < 7; ++i) {
        pattern = getRotatePattern3x3(pattern);
        if (i == 3) {
            pattern = getReversePattern3x3(pattern);
        }
        bit_pattern = getPattern3x3ToBit(pattern);
        if (bit_pattern < min_bit_pattern) {
            min_bit_pattern = bit_pattern;
        }
    }

    return min_bit_pattern;
}

std::array<int, 25> MakePattern::getPattern5x5(const std::array<int, karray_board_size> &go_board, int pos)
{
    std::array<int, 25> pattern;
    int start_intdex = pos - 2 * kexpanded_board_size - 2;
    for (int i = 0; i < 5; ++i) {
        pattern[i] = go_board[i + start_intdex];
        pattern[i + 5] = go_board[i + start_intdex + kexpanded_board_size];
        pattern[i + 10] = go_board[i + start_intdex + 2 * kexpanded_board_size];
        pattern[i + 15] = go_board[i + start_intdex + 3 * kexpanded_board_size];
        pattern[i + 20] = go_board[i + start_intdex + 4 * kexpanded_board_size];
    }

    return pattern;
}

std::array<int, 25> MakePattern::getRotatePattern5x5(const std::array<int, 25> &pattern)
{
    std::array<int, 25> rotate_pattern;
    rotate_pattern[0] = pattern[20];
    rotate_pattern[1] = pattern[15];
    rotate_pattern[2] = pattern[10];
    rotate_pattern[3] = pattern[5];
    rotate_pattern[4] = pattern[0];
    rotate_pattern[5] = pattern[21];
    rotate_pattern[6] = pattern[16];
    rotate_pattern[7] = pattern[11];
    rotate_pattern[8] = pattern[6];
    rotate_pattern[9] = pattern[1];
    rotate_pattern[10] = pattern[22];
    rotate_pattern[11] = pattern[17];
    rotate_pattern[12] = pattern[12];
    rotate_pattern[13] = pattern[7];
    rotate_pattern[14] = pattern[2];
    rotate_pattern[15] = pattern[23];
    rotate_pattern[16] = pattern[18];
    rotate_pattern[17] = pattern[13];
    rotate_pattern[18] = pattern[8];
    rotate_pattern[19] = pattern[3];
    rotate_pattern[20] = pattern[24];
    rotate_pattern[21] = pattern[19];
    rotate_pattern[22] = pattern[14];
    rotate_pattern[23] = pattern[9];
    rotate_pattern[24] = pattern[4];

    return rotate_pattern;
}

std::array<int, 25> MakePattern::getReversePattern5x5(const std::array<int, 25> &pattern)
{
    std::array<int, 25> reverse_pattern;
    reverse_pattern[0] = pattern[4];
    reverse_pattern[1] = pattern[3];
    reverse_pattern[2] = pattern[2];
    reverse_pattern[3] = pattern[1];
    reverse_pattern[4] = pattern[0];
    reverse_pattern[5] = pattern[9];
    reverse_pattern[6] = pattern[8];
    reverse_pattern[7] = pattern[7];
    reverse_pattern[8] = pattern[6];
    reverse_pattern[9] = pattern[5];
    reverse_pattern[10] = pattern[14];
    reverse_pattern[11] = pattern[13];
    reverse_pattern[12] = pattern[12];
    reverse_pattern[13] = pattern[11];
    reverse_pattern[14] = pattern[10];
    reverse_pattern[15] = pattern[19];
    reverse_pattern[16] = pattern[18];
    reverse_pattern[17] = pattern[17];
    reverse_pattern[18] = pattern[16];
    reverse_pattern[19] = pattern[15];
    reverse_pattern[20] = pattern[24];
    reverse_pattern[21] = pattern[23];
    reverse_pattern[22] = pattern[22];
    reverse_pattern[23] = pattern[21];
    reverse_pattern[24] = pattern[20];

    return reverse_pattern;
}

std::bitset<50> MakePattern::getBitPattern5x5(const std::array<int, 25> &pattern)
{
    std::bitset<50> bit_pattern;
    for (int i = 0; i < 25; ++i) {
        bit_pattern.set(2 * i, ((pattern[i] & 1) ? true: false));
        bit_pattern.set(2 * i + 1, ((pattern[i] & 2) ? true: false));
    }

    return bit_pattern;
}

std::bitset<338> MakePattern::getBitPattern9x9(const std::array<int, karray_board_size> &pattern)
{
    std::bitset<338> bit_pattern;
    for (int i = 0; i < karray_board_size; ++i) {
        bit_pattern.set(2 * i, ((pattern[i] & 1) ? true: false));
        bit_pattern.set(2 * i + 1, ((pattern[i] & 2) ? true: false));
    }

    return bit_pattern;
}

std::array<int, karray_board_size> MakePattern::getRotatePattern9x9(const std::array<int, karray_board_size> &pattern)
{
    std::array<int, karray_board_size> rotate_pattern;
    rotate_pattern.fill(Wall);
    for (int i = 0; i < kboard_size; ++i) {
        for (int j = 0;  j < kboard_size; ++j) {
            rotate_pattern[i * kexpanded_board_size + j + 28] = pattern[132 + i - kexpanded_board_size * j];
            // std::cerr << i * kboard_size + j << " " << pattern[132 + i - kexpanded_board_size * j] << std::endl;
        }
    }
    return rotate_pattern;
}

std::array<int, karray_board_size> MakePattern::getReversePattern9x9(const std::array<int, karray_board_size> &pattern)
{
    std::array<int, karray_board_size> reverse_pattern;
    reverse_pattern.fill(Wall);
    for (int i = 0; i < kboard_size; ++i) {
        for (int j = 0;  j < kboard_size; ++j) {
            reverse_pattern[i * kexpanded_board_size + j + 28] = pattern[i * kexpanded_board_size - j + 28 + 8];
        }
    }
    return reverse_pattern;
}

std::array<int, 9> MakePattern::getBitToPattern3x3(int bit_pattern)
{
    std::array<int, 9> pattern;
    for (int i = 0; i < 9 ; ++i) {
        pattern[i] = (int)(bit_pattern & 3);
        bit_pattern >>= 2;
    }
    return pattern;
}

void MakePattern::doMakePattern()
{
    DIR *dir;
    int color = Black;
    char ch, x, y, z, w;
    int num_x, num_y;
    int record_count = 0;

    struct dirent *dp;
    std::string path = "/home/patterns";

    if ((dir = opendir(path.c_str())) == NULL) {
        std::cerr << "not found directory" << std::endl;
        exit(1);
    }

    for (int i = 0; i < karray_board_size; ++i) {
        for (int j = 0; j < karray_board_size; ++j) {
            transition_count_[i][j].fill(0);
            for (int k = 0; k < karray_board_size; ++k) {
                transition_count_move_[i][j][k].second = k;
                transition_count_move_[i][j][k].first = 0;
            }
        }
        two_transition_count_[i].fill(0);

        for (int j = 0; j < 5; ++j) {
            pattern3x3_with_pos_count_[0][j][i].fill(0);
            pattern3x3_with_pos_count_[1][j][i].fill(0);
        }
    }

    for (int i = 0; i < kboard_square_size; ++i) {
        for (int j = 0; j < kboard_square_size; ++j) {
            for (int k = 0; k < kboard_square_size; ++k) {
                transition_count_move_[board9x9_index[i]][board9x9_index[j]][board9x9_index[k]].first = 1;
            }
        }
    }

    pattern3x3_count_[0].fill(0);
    pattern3x3_count_[1].fill(0);

    each_with_pos_move_count_.fill(0);
    result_pattern_.fill(0);

    while ((dp = readdir(dir)) != NULL) {
        if (dp->d_name[0] == '.') {
            continue;
        }
        std::string file_name(dp->d_name);
        if (file_name.find(".sgf") == std::string::npos) {
            continue;
        }

        file_name = path + "/" + file_name;
        std::fstream fin(file_name.c_str());
        GoBoard go_board;
        int pre_pos = -1;
        int second_pre_pos = -1;
        int third_pre_pos = -1;
        int is_teacher[2] = {0, 0};
        color = Black;

        ++record_count;
        int move_count = 0;

        int result = 3;

        while (fin) {
            fin >> ch;
            if (ch == ';') {
                fin >> ch;
                if (ch == 'B' || ch == 'W') {
                    fin >> ch;
                    if (ch == '[') {
                        fin >> x;
                        if (x != ']') {
                            fin >> y>> ch;
                            if (ch == ']') {
                                num_x = x - 'a' + 2;
                                num_y = y - 'a' + 2;
                                num_y *= kexpanded_board_size;
                                int pos = num_x + num_y;

                                if (is_teacher[color] == 1) {
                                    std::array<int, 25> pattern5x5 = getPattern5x5(go_board.getGoBoard(), pos);
                                    std::array<int, karray_board_size> pattern9x9 = go_board.getGoBoard(), index_board9x9;
                                    index_board9x9.fill(0);
                                    index_board9x9[pos] = 1;

                                    std::bitset<50> bit_pattern5x5 = getBitPattern5x5(pattern5x5);
                                    std::bitset<338> bit_pattern9x9 = getBitPattern9x9(pattern9x9);
                                    if (color == Black) {
                                        ++black_pattern5x5_count_[bit_pattern5x5];
                                        ++black_pattern9x9_count_[bit_pattern9x9][pos];

                                    } else if (color == White) {
                                        ++white_pattern5x5_count_[bit_pattern5x5];
                                        ++white_pattern9x9_count_[bit_pattern9x9][pos];


                                    }

                                    for (int i = 0; i < 7; ++i) {
                                        pattern5x5 = getRotatePattern5x5(pattern5x5);
                                        pattern9x9 = getRotatePattern9x9(pattern9x9);
                                        index_board9x9 = getRotatePattern9x9(index_board9x9);
                                        if (i == 3) {
                                            pattern5x5 = getReversePattern5x5(pattern5x5);
                                            pattern9x9 = getReversePattern9x9(pattern9x9);
                                            index_board9x9 = getReversePattern9x9(index_board9x9);
                                        }
                                        bit_pattern5x5 = getBitPattern5x5(pattern5x5);
                                        bit_pattern9x9 = getBitPattern9x9(pattern9x9);
                                        // printBitPattern9x9(bit_pattern9x9);
                                        int tmp_pos = std::distance(index_board9x9.begin(),
                                                                    std::find(index_board9x9.begin(), index_board9x9.end(), 1));
                                        if (color == Black) {
                                            ++black_pattern5x5_count_[bit_pattern5x5];
                                            ++black_pattern9x9_count_[bit_pattern9x9][tmp_pos];
                                        } else if (color == White) {
                                            ++white_pattern5x5_count_[bit_pattern5x5];
                                            ++white_pattern9x9_count_[bit_pattern9x9][tmp_pos];
                                        }
                                    }


                                    if (getManhattanDistance(pre_pos, pos) <= 2 || pre_pos == -1) {

                                        std::array<int,  karray_board_size> current_board = go_board.getGoBoard();
                                        std::array<int, 9> pattern3x3;

                                        pattern3x3[0] = current_board[getWest(getNorth(pos))];
                                        pattern3x3[1] = current_board[getNorth(pos)];
                                        pattern3x3[2] = current_board[getEast(getNorth(pos))];
                                        pattern3x3[3] = current_board[getWest(pos)];
                                        pattern3x3[4] = Empty;
                                        pattern3x3[5] = current_board[getEast(pos)];
                                        pattern3x3[6] = current_board[getWest(getSouth(pos))];
                                        pattern3x3[7] = current_board[getSouth(pos)];
                                        pattern3x3[8] = current_board[getEast(getSouth(pos))];

                                        if (color == Black) {
                                            ++pattern3x3_count_[0][getMinPattern3x3ToBit(pattern3x3)];
                                        }
                                        else if (color == White) {
                                            ++pattern3x3_count_[1][getMinPattern3x3ToBit(pattern3x3)];
                                        }

                                        int wall_count = 3;
                                        std::array<int, 9> around_pattern3x3;
                                        int center_pos = pos;
                                        around_pattern3x3 = getPattern3x3(go_board.getGoBoard(), center_pos);

                                        if (getWallCount(around_pattern3x3) < wall_count) {
                                            ++pattern3x3_with_pos_count_[color][0][pos][getPattern3x3ToBit(around_pattern3x3)];
                                            ++each_with_pos_move_count_[center_pos];
                                        }

                                        center_pos = getNorth(getWest(pos));
                                        around_pattern3x3 = getPattern3x3(go_board.getGoBoard(), center_pos);


                                        if (getWallCount(around_pattern3x3) < wall_count) {
                                            ++pattern3x3_with_pos_count_[color][1][pos][getPattern3x3ToBit(around_pattern3x3)];
                                        }

                                        center_pos = getNorth(getEast(pos));
                                        around_pattern3x3 = getPattern3x3(go_board.getGoBoard(), center_pos);

                                        if (getWallCount(around_pattern3x3) < wall_count) {
                                            ++pattern3x3_with_pos_count_[color][2][pos][getPattern3x3ToBit(around_pattern3x3)];
                                        }

                                        center_pos = getSouth(getWest(pos));
                                        around_pattern3x3 = getPattern3x3(go_board.getGoBoard(), center_pos);

                                        if (getWallCount(around_pattern3x3) < wall_count) {
                                            ++pattern3x3_with_pos_count_[color][3][pos][getPattern3x3ToBit(around_pattern3x3)];
                                        }

                                        center_pos = getSouth(getEast(pos));
                                        around_pattern3x3 = getPattern3x3(go_board.getGoBoard(), center_pos);

                                        if (getWallCount(around_pattern3x3) < wall_count) {
                                            ++pattern3x3_with_pos_count_[color][4][pos][getPattern3x3ToBit(around_pattern3x3)];
                                        }


                                    }
                                }

                                if (third_pre_pos >= kboard_start_index && second_pre_pos >= kboard_start_index && pre_pos >= kboard_start_index && pos >= kboard_start_index) {
                                    ++four_transition_count_[third_pre_pos][second_pre_pos][pre_pos][pos];
                                    if (std::find(four_transition_move_[third_pre_pos][second_pre_pos][pre_pos].begin(),
                                                  four_transition_move_[third_pre_pos][second_pre_pos][pre_pos].end(), pos)
                                                    == four_transition_move_[third_pre_pos][second_pre_pos][pre_pos].end()) {
                                        four_transition_move_[third_pre_pos][second_pre_pos][pre_pos].push_back(pos);
                                    }

                                     /// total
                                    ++four_transition_count_[third_pre_pos][second_pre_pos][pre_pos][0];
                                 }

                                if (second_pre_pos >= kboard_start_index && pre_pos >= kboard_start_index && pos >= kboard_start_index) {
                                    ++transition_count_[second_pre_pos][pre_pos][pos];
                                    /// total
                                    ++transition_count_[second_pre_pos][pre_pos][0];


                                    ++transition_count_move_[second_pre_pos][pre_pos][pos].first; // += 5;
                                }

                                if (pre_pos >= kboard_start_index && pos >= kboard_start_index) {
                                    ++two_transition_count_[pre_pos][pos];
                                    ++two_transition_count_[pre_pos][0];
                                    for (int i = 0; i < karray_board_size; ++i) {
                                        ++transition_count_move_[i][pre_pos][pos].first;
                                    }
                                }


                                go_board.setStone(pos, color);
                                move_count++;


                                std::bitset<243> pattern243 = getPattern243(go_board.getGoBoard());
                                for (int i = 0; i < 8; ++i) {
                                    if (i == 4) {
                                        pattern243 = getReversePattern243(pattern243);
                                    }


                                    if(color == Black) {
                                        if (result == 0) {
                                            ++pattern243_count_[go_board.getStoneCount()][pattern243][0];
                                        }
                                        else if (result == 2) {
                                            ++pattern243_count_[go_board.getStoneCount()][pattern243][0];
                                        }
                                        ++pattern243_count_[go_board.getStoneCount()][pattern243][1];
                                    }
                                    else if (color == White) {
                                        if (result == 1) {
                                            ++pattern243_count_[go_board.getStoneCount()][pattern243][2];
                                        }
                                        else if (result == 2) {
                                            ++pattern243_count_[go_board.getStoneCount()][pattern243][2];
                                        }
                                        ++pattern243_count_[go_board.getStoneCount()][pattern243][3];
                                    }
                                    else {
                                        std::cerr << result << std::endl;
                                        exit(0);
                                    }

                                    pattern243 = getRotatePattern243(pattern243);
                                }


                                third_pre_pos = second_pre_pos;
                                second_pre_pos = pre_pos;
                                pre_pos = pos;
                            }
                        }
                        color = (color == Black ? White : Black);
                    }
                }
            }
            else if (ch == 'R') {
                fin >> ch;
                if (ch == 'E') {
                    fin >> ch >> x;
                    if (ch == '[' && x == 'B') {
                        is_teacher[1] = 0;
                        is_teacher[0] = 1;
                        result = 0;
                    }
                    else if (ch == '[' && x == 'W') {
                        is_teacher[0] = 0;
                        is_teacher[1] = 1;
                        result = 1;
                    }
                    else if (ch == '[' && x == '0') {
                        is_teacher[0] = 1;
                        is_teacher[1] = 1;
                        result = 2;
                    }
                }
            }
        }

        fin.close();
    }

    closedir(dir);

    for (int i = 1; i < pattern3x3_count_[0].size(); ++i) {
        int min_bitpattern = getMinPattern3x3ToBit(getBitToPattern3x3(i));
        if (min_bitpattern != i) {
            pattern3x3_count_[0][i] = pattern3x3_count_[0][min_bitpattern];
            pattern3x3_count_[1][i] = pattern3x3_count_[1][min_bitpattern];
        }
    }

    for (int i = 0; i < 262144; ++i) {
        std::bitset<18> bit_pattern((int) i);
        black_bit_pattern3x3_count_[bit_pattern] = pattern3x3_count_[0][i];
        white_bit_pattern3x3_count_[bit_pattern] = pattern3x3_count_[1][i];

        // result pattern
        std::array<int, 9> pattern = getBitToPattern3x3(i);
        int score = 0;
        for (int j = 0; j < 9; ++j) {
            if (pattern[j] == Black) {
                ++score;
            }
            else if (pattern[j] == White) {
                --score;
            }
            else if (pattern[j] == Empty) {
                if (j == 0) {
                    if (pattern[1] == Black) {
                        ++score;
                        continue;
                    }
                    else if (pattern[1] == White) {
                        --score;
                        continue;
                    }
                    else if (pattern[3] == Black) {
                        ++score;
                        continue;
                    }
                    else if (pattern[3] == White) {
                        --score;
                        continue;
                    }
                }
                else if (j == 1) {
                    if (pattern[0] == Black) {
                        ++score;
                        continue;
                    }
                    else if (pattern[0] == White) {
                        --score;
                        continue;
                    }
                    else if (pattern[2] == Black) {
                        ++score;
                        continue;
                    }
                    else if (pattern[2] == White) {
                        --score;
                        continue;
                    }
                    else if (pattern[4] == Black) {
                        ++score;
                        continue;
                    }
                    else if (pattern[4] == White) {
                        --score;
                        continue;
                    }
                }
                else if (j == 2) {
                    if (pattern[1] == Black) {
                        ++score;
                        continue;
                    }
                    else if (pattern[1] == White) {
                        --score;
                        continue;
                    }
                    else if (pattern[5] == Black) {
                        ++score;
                        continue;
                    }
                    else if (pattern[5] == White) {
                        --score;
                        continue;
                    }
                }
                else if (j == 3) {
                    if (pattern[0] == Black) {
                        ++score;
                        continue;
                    }
                    else if (pattern[0] == White) {
                        --score;
                        continue;
                    }
                    else if (pattern[4] == Black) {
                        ++score;
                        continue;
                    }
                    else if (pattern[4] == White) {
                        --score;
                        continue;
                    }
                    else if (pattern[6] == Black) {
                        ++score;
                        continue;
                    }
                    else if (pattern[6] == White) {
                        --score;
                        continue;
                    }
                }
                else if (j == 4) {
                    if (pattern[1] == Black) {
                        ++score;
                        continue;
                    }
                    else if (pattern[1] == White) {
                        --score;
                        continue;
                    }
                    else if (pattern[3] == Black) {
                        ++score;
                        continue;
                    }
                    else if (pattern[3] == White) {
                        --score;
                        continue;
                    }
                    else if (pattern[5] == Black) {
                        ++score;
                        continue;
                    }
                    else if (pattern[5] == White) {
                        --score;
                        continue;
                    }
                    else if (pattern[7] == Black) {
                        ++score;
                        continue;
                    }
                    else if (pattern[7] == White) {
                        --score;
                        continue;
                    }
                }
                else if (j == 5) {
                    if (pattern[2] == Black) {
                        ++score;
                        continue;
                    }
                    else if (pattern[2] == White) {
                        --score;
                        continue;
                    }
                    else if (pattern[4] == Black) {
                        ++score;
                        continue;
                    }
                    else if (pattern[4] == White) {
                        --score;
                        continue;
                    }
                    else if (pattern[8] == Black) {
                        ++score;
                        continue;
                    }
                    else if (pattern[8] == White) {
                        --score;
                        continue;
                    }
                }
                else if (j == 6) {
                    if (pattern[3] == Black) {
                        ++score;
                        continue;
                    }
                    else if (pattern[3] == White) {
                        --score;
                        continue;
                    }
                    else if (pattern[7] == Black) {
                        ++score;
                        continue;
                    }
                    else if (pattern[7] == White) {
                        --score;
                        continue;
                    }
                }
                else if (j == 7) {
                    if (pattern[4] == Black) {
                        ++score;
                        continue;
                    }
                    else if (pattern[4] == White) {
                        --score;
                        continue;
                    }
                    else if (pattern[6] == Black) {
                        ++score;
                        continue;
                    }
                    else if (pattern[6] == White) {
                        --score;
                        continue;
                    }
                    else if (pattern[8] == Black) {
                        ++score;
                        continue;
                    }
                    else if (pattern[8] == White) {
                        --score;
                        continue;
                    }
                }
                else if (j == 8) {
                    if (pattern[5] == Black) {
                        ++score;
                        continue;
                    }
                    else if (pattern[5] == White) {
                        --score;
                        continue;
                    }
                    else if (pattern[7] == Black) {
                        ++score;
                        continue;
                    }
                    else if (pattern[7] == White) {
                        --score;
                        continue;
                    }
                }
            }
        }
        result_pattern_[i] = score;
    }

    std::random_device rd;
    std::mt19937 generator(rd());
    for (int i = 0; i < karray_board_size; ++i) {
        for (int j = 0; j < karray_board_size; ++j) {
            std::sort(transition_count_move_[i][j].rbegin(), transition_count_move_[i][j].rend());
            std::shuffle(transition_count_move_[i][j].begin() + kboard_square_size / kboard_size, transition_count_move_[i][j].begin() + kboard_square_size, generator);
        }
    }

    for (int i = 0; i < krandom_table_size; ++i) {
        // set
        for (int j = 0; j < kboard_square_size; ++j) {
            random_table_[i][j] = board9x9_index[j];
        }
        std::shuffle(random_table_[i].begin(), random_table_[i].end(), generator);
    }

    pattern3x3_count_[0][174762] = pattern3x3_count_[1][174762] = 0;
    std::cerr << "record_count " << record_count << std::endl;
}

int MakePattern::getResultBoard9x9FromPattern(const std::array<int, karray_board_size> &pattern_go_board)
{
    int score = 0;
    for (int i = 0; i < 9; ++i) {
        score += result_pattern_[pattern_go_board[board9x9_result_index[i]]];
    }
    return score;
}

std::bitset<243> MakePattern::getPattern243(const std::array<int, karray_board_size> &go_board)
{
    std::bitset<243> pattern243;
    pattern243.reset();
    for (int i = 0; i < kboard_square_size; ++i) {
        int color = go_board[board9x9_index[i]];
        int base = i * 3;
        if (color == Empty) {
            // pattern243[base] = 1;
        }
        else if (color == Black) {
            pattern243[base + 1] = 1;
        }
        else {
            pattern243[base + 2] = 1;
        }
    }
    return pattern243;
}

std::bitset<243> MakePattern::getRotatePattern243(const std::bitset<243> &pattern)
{
    std::bitset<243> rotate_pattern;
    int start_index = 72;
    for (int i = 0; i < kboard_size; ++i) {
        for (int j = start_index, k = 0; j >= 0; j -= kboard_size, k += 3) {
            int base = 3 * i * kboard_size + k;
            rotate_pattern[base] = pattern[j * 3];
            rotate_pattern[base + 1] = pattern[j * 3 + 1];
            rotate_pattern[base + 2] = pattern[j * 3 + 2];
        }
        ++start_index;
    }

    return rotate_pattern;
}

std::bitset<243> MakePattern::getReversePattern243(const std::bitset<243> &pattern)
{
    std::bitset<243> reverse_pattern;
    for (int i = 0; i < kboard_size; ++i) {
        int start_index = 3 * ((i + 1) * kboard_size - 1);
        for (int j = 0; j < 9; ++j) {
            int base = 3 * kboard_size * i + 3 * j;
            reverse_pattern[base] = pattern[start_index - 3 * j];
            reverse_pattern[base + 1] = pattern[start_index - 3 * j + 1];
            reverse_pattern[base + 2] = pattern[start_index - 3 * j + 2];
        }
    }

    return reverse_pattern;
}

int MakePattern::getWallCount(std::array<int, 9> pattern3x3)
{
    int total_count = 0;
    for (int i = 0; i < 9; ++i) {
        if (pattern3x3[i] == Wall) {
            ++total_count;
        }
    }
    return total_count;
}


std::array<double,  karray_board_size> MakePattern::getFrequencyBoard(const GoBoard &go_board, int color, int mode)
{
    std::array<int,  karray_board_size> current_go_board = go_board.getGoBoard();
    std::array<double,  karray_board_size> frequency_board, tmp_board;

    frequency_board.fill(0.0);

    if (mode == 0) {
        std::array<int, 9> pattern3x3;
        int total_count = 0;

        for (int i = kboard_start_index; i <  karray_board_size - kexpanded_board_size; ++i) {
            if (current_go_board[i] != Empty) {
                continue;
            }

            pattern3x3[0] = current_go_board[getWest(getNorth(i))];
            pattern3x3[1] = current_go_board[getNorth(i)];
            pattern3x3[2] = current_go_board[getEast(getNorth(i))];
            pattern3x3[3] = current_go_board[getWest(i)];
            pattern3x3[4] = Empty;
            pattern3x3[5] = current_go_board[getEast(i)];
            pattern3x3[6] = current_go_board[getWest(getSouth(i))];
            pattern3x3[7] = current_go_board[getSouth(i)];
            pattern3x3[8] = current_go_board[getEast(getSouth(i))];

            if (color == Black) {
                frequency_board[i] = pattern3x3_count_[0][getPattern3x3ToBit(pattern3x3)];
                total_count += frequency_board[i];
                // std::cout << getMinPattern3x3ToBit(pattern3x3) << " " << pattern3x3_count_[0][getMinPattern3x3ToBit(pattern3x3)] << std::endl;
            }
            else if (color == White) {
                frequency_board[i] = pattern3x3_count_[1][getPattern3x3ToBit(pattern3x3)];
                total_count += frequency_board[i];
            }
        }
        if (total_count == 0) {
            return frequency_board;
        }

        tmp_board = frequency_board;

    }
    else if (mode == 1) {
        std::bitset<50> bit_pattern5x5;
        std::array<int, 25> pattern5x5;
        std::unordered_map<std::bitset<50>, int>::const_iterator it;
        // google::sparse_hash_map<std::bitset<50>, int>::const_iterator it;
        for (int i = kboard_start_index; i <  karray_board_size - kexpanded_board_size; ++i) {
            if (current_go_board[i] != Empty) {
                continue;
            }
            pattern5x5 = getPattern5x5(current_go_board, i);
            bit_pattern5x5 = getBitPattern5x5(pattern5x5);

            if (color == Black) {
                it = black_pattern5x5_count_.find(bit_pattern5x5);
                if (it != black_pattern5x5_count_.end()) {
                }
                frequency_board[i] = black_pattern5x5_count_[bit_pattern5x5];
            }
            else if (color == White) {
                it = white_pattern5x5_count_.find(bit_pattern5x5);
                if (it != white_pattern5x5_count_.end()) {
                    frequency_board[i] = black_pattern5x5_count_[bit_pattern5x5];
                }
            }
        }
    }
    else if (mode == 2) {
        std::bitset<338> bit_pattern9x9;
        std::array<int, karray_board_size> pattern9x9;
        std::unordered_map<std::bitset<338>, std::unordered_map<int, int> >::iterator it;
        // google::sparse_hash_map<std::bitset<338>, google::sparse_hash_map<int, int> >::iterator it;

        pattern9x9 = current_go_board;
        bit_pattern9x9 = getBitPattern9x9(pattern9x9);

        if (color == Black) {
            it = black_pattern9x9_count_.find(bit_pattern9x9);
            if (it != black_pattern9x9_count_.end()) {
                for (auto its = black_pattern9x9_count_[bit_pattern9x9].begin(); its != black_pattern9x9_count_[bit_pattern9x9].end(); ++its) {
                    if ((*its).second > 0) {
                        frequency_board[(*its).first] = 1.0;
                    }
                }
            }
         }
         else if (color == White) {
            it = white_pattern9x9_count_.find(bit_pattern9x9);
            if (it != white_pattern9x9_count_.end()) {
                for (auto its = white_pattern9x9_count_[bit_pattern9x9].begin(); its != white_pattern9x9_count_[bit_pattern9x9].end(); ++its) {
                    if ((*its).second > 0) {
                        frequency_board[(*its).first] = 1.0;
                    }
                }
            }
        }
    }
    else if (mode == 3) {
        std::array<int, 9> pattern3x3;
        int total_count = 0;
        double tota_frequency = 0.0;

        for (int i = kboard_start_index; i <  karray_board_size - kexpanded_board_size; ++i) {
            if (current_go_board[i] != Empty) {
                continue;
            }
            double frequency = 0.0;
            int wall_count = 0;
            // go_board[i] = color;
            int center_pos = i;
            int limit_wall_count = 3;
            int pos = i;
            pattern3x3 = getPattern3x3(current_go_board, center_pos);
            frequency += pattern3x3_with_pos_count_[color][0][pos][getPattern3x3ToBit(pattern3x3)];
            if (getWallCount(pattern3x3) > limit_wall_count) {
                ++wall_count;
            }


            center_pos = getWest(getNorth(i));
            pattern3x3 = getPattern3x3(current_go_board, center_pos);
            frequency += pattern3x3_with_pos_count_[color][1][pos][getPattern3x3ToBit(pattern3x3)];
            if (getWallCount(pattern3x3) > limit_wall_count) {
                ++wall_count;
            }

            center_pos =  getEast(getNorth(i));
            pattern3x3 = getPattern3x3(current_go_board, center_pos);
            frequency += pattern3x3_with_pos_count_[color][2][pos][getPattern3x3ToBit(pattern3x3)];
            if (getWallCount(pattern3x3) > limit_wall_count) {
                ++wall_count;
            }

            center_pos =  getWest(getSouth(i));
            pattern3x3 = getPattern3x3(current_go_board, center_pos);
            frequency += pattern3x3_with_pos_count_[color][3][pos][getPattern3x3ToBit(pattern3x3)];
            if (getWallCount(pattern3x3) > limit_wall_count) {
                ++wall_count;
            }

            center_pos =  getEast(getSouth(i));
            pattern3x3 = getPattern3x3(current_go_board, center_pos);
            frequency += pattern3x3_with_pos_count_[color][4][pos][getPattern3x3ToBit(pattern3x3)];
            if (getWallCount(pattern3x3) > limit_wall_count) {
                ++wall_count;
            }

            frequency_board[i] = frequency;
            tota_frequency += frequency;
        }
    }
    else if (mode == 4) {

        int pre_pos = go_board.getPrePosition();
        int second_pre_pos = go_board.getSecondPrePosition();
        std::array<std::pair<int, int>,  karray_board_size> board;
        double sum = 0.0;
        for (int i = 0; i < karray_board_size; ++i) {
            board[i].first = transition_count_move_[second_pre_pos][pre_pos][i].second;
            board[i].second = transition_count_move_[second_pre_pos][pre_pos][i].first;
        }
        std::sort(board.begin(), board.end());

        for (int i = 0; i < karray_board_size; ++i) {
            frequency_board[i] = board[i].second;
            sum += board[i].second;
        }
        if (sum > 0) {
            for (int i = 0; i < karray_board_size; ++i) {
                frequency_board[i] = frequency_board[i] / sum;
            }
        }

    }

    return frequency_board;
}


