#include <array>

#include "global.h"
#include "not_read.h"
#include "go_board.h"


NotRead::NotRead()
{
}

/*
    28, 29, 30, 31, 32, 33, 34, 35, 36,
    41, 42, 43, 44, 45, 46, 47, 48, 49,
    54, 55, 56, 57, 58, 59, 60, 61, 62,
    67, 68, 69, 70, 71, 72, 73, 74, 75,
    80, 81, 82, 83, 84, 85, 86, 87, 88,
    93, 94, 95, 96, 97, 98, 99, 100, 101,
    106, 107, 108, 109, 110, 111, 112, 113, 114,
    119, 120, 121, 122, 123, 124, 125, 126, 127,
    132, 133, 134, 135, 136, 137, 138, 139, 140
*/

bool NotRead::isNotRead(const GoBoard &go_board, int pos, int color, int turn)
{
    if (pos < kboard_start_index) {
        return false;
    }
    if (turn > 20) {
        return false;
    }

    std::array<int, karray_board_size> board = go_board.getGoBoard();

    std::array<int, 4> count_color3x3 = {0};
    std::array<int, 4> count_color5x5 = {0};
    int inverse_color = (color == Black ? White : Black);
    int x = pos % kexpanded_board_size;
    int y = pos / kexpanded_board_size;

    ++count_color3x3[board[getNorthWest(pos)]];
    ++count_color3x3[board[getNorth(pos)]];
    ++count_color3x3[board[getNorthEast(pos)]];
    ++count_color3x3[board[getWest(pos)]];
    ++count_color3x3[board[pos]];
    ++count_color3x3[board[getEast(pos)]];
    ++count_color3x3[board[getSouthWest(pos)]];
    ++count_color3x3[board[getSouth(pos)]];
    ++count_color3x3[board[getSouthEast(pos)]];

    count_color5x5 = count_color3x3;

    ++count_color5x5[board[getNorthWest(getNorthWest(pos))]];
    ++count_color5x5[board[getNorthWest(getNorth(pos))]];
    ++count_color5x5[board[getNorth(getNorth(pos))]];
    ++count_color5x5[board[getNorthEast(getNorth(pos))]];
    ++count_color5x5[board[getNorthEast(getNorthEast(pos))]];

    ++count_color5x5[board[getNorthWest(getWest(pos))]];
    ++count_color5x5[board[getNorthEast(getEast(pos))]];

    ++count_color5x5[board[getWest(getWest(pos))]];
    ++count_color5x5[board[getEast(getEast(pos))]];

    ++count_color5x5[board[getSouthWest(getWest(pos))]];
    ++count_color5x5[board[getSouthEast(getEast(pos))]];

    ++count_color5x5[board[getSouthWest(getSouthWest(pos))]];
    ++count_color5x5[board[getSouthWest(getEast(pos))]];
    ++count_color5x5[board[getEast(getEast(pos))]];
    ++count_color5x5[board[getSouthEast(getSouth(pos))]];
    ++count_color5x5[board[getSouthEast(getSouthEast(pos))]];

    if (x >= 5 && x <= 7 && y >= 5 && y <= 7) {
        if (count_color3x3[inverse_color] == 0
                && count_color3x3[color] > 1) {
            return true;
        }
    }
    if (x >= 5 && x <= 7 && y >= 5 && y <= 7) {
        if (count_color3x3[color] > 1) {
            return true;
        }
    }

    if (x == 2 || x == 10 || y == 2 || y == 10) {
        if (count_color5x5[color] == 0) {
            return true;
        }
    }
    if (x == 3 || x == 9 || y == 3 || y == 9) {
        if (count_color5x5[color] == 0) {
            return true;
        }
    }


    return false;
}
